package com.zxhy.hfilemanagermaster.largefile

import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.hfilemanagermaster.R
import com.example.hfilemanagermaster.databinding.ItemMediaSelectBinding
import com.zxhy.hfilemanagermaster.data.MediaDataC
import com.zxhy.hfilemanagermaster.glide.loadIntoImageView
import com.zxhy.hfilemanagermaster.knife.inflate

class LagerFileSelectorAdapter(
    private val selectAction: ((flag: Boolean) -> Unit)? = null
) : RecyclerView.Adapter<LagerFileSelectorAdapter.MediaSelectViewHolder>() {
    private val mediaList = arrayListOf<MediaDataC>()

    class MediaSelectViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val binding = ItemMediaSelectBinding.bind(view)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MediaSelectViewHolder {
        val root = R.layout.item_media_select.inflate(parent)
        return MediaSelectViewHolder(root)
    }

    override fun getItemCount(): Int {
        return mediaList.size
    }

    override fun onBindViewHolder(holder: MediaSelectViewHolder, position: Int) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        holder.binding.apply {
            loadIntoImageView(context, data.uri, iv)

            tvName.text = data.name
            tvSize.text = data.size
            ivSelector.isSelected = data.select
            flSelector.setOnClickListener {
                data.select = !data.select
                notifyItemChanged(position, "单条刷新")
            }
        }
        if (data == mediaList.last()) {
            selectAction?.invoke(mediaList.all { it.select })
        }
    }

    override fun onBindViewHolder(
        holder: MediaSelectViewHolder,
        position: Int,
        payloads: MutableList<Any>
    ) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        //判断是做局部刷新还是单条刷新
        if (payloads.isEmpty()) {//局部刷新
            holder.binding.apply {
                loadIntoImageView(context, data.uri, iv)

                tvName.text = data.name
                tvSize.text = data.size
                ivSelector.isSelected = data.select
                flSelector.setOnClickListener {
                    data.select = !data.select
                    notifyItemChanged(position, "单条刷新")
                }
                if (data == mediaList.last()) {
                    selectAction?.invoke(mediaList.all { it.select })
                }
            }
        } else {// 单条刷新
            holder.binding.apply {
                ivSelector.isSelected = data.select
            }
            super.onBindViewHolder(holder, position, payloads)

            selectAction?.invoke(mediaList.all { it.select })
        }

    }

    @SuppressLint("NotifyDataSetChanged")
    fun setData(data: List<MediaDataC>) {
        mediaList.clear()
        mediaList.addAll(data)
        notifyDataSetChanged()
    }


    @SuppressLint("NotifyDataSetChanged")
    fun setToggleSelect(): Boolean {
        val flag = mediaList.all { it.select }
        mediaList.forEach { it.select = !flag }
        notifyDataSetChanged()
        return !flag
    }

    fun getSelectSize(): Int {
        return mediaList.count { it.select }
    }

}